#!/bin/bash

SCRIPTDIR=$(dirname "${BASH_SOURCE}")

AUTHOR="Janne Hellas"
VERSION="1.0"
LICENSE="Public Domain or equivalent."
LINFO="This software is provided \"as-is\" without any warranties or liabilities."

if [[ ! -f "$SCRIPTDIR/charactermap" ]]; then
   echo "$0: charactermap file missing." 1>&2
   exit 2
fi

if [[ $# -eq 0 ]]; then
   echo "FF6 string converter v$VERSION"
   echo ""
   echo "Usage: ./ff6name.sh [Name Hex]"
   echo ""
   echo "The utility will convert hex values to characters defined in the charactermap."
   echo ""
   echo "License: $LICENSE"
   echo "$LINFO"
   exit 0
fi

NAMEHEX="$1"

if [[ ! $NAMEHEX =~ ^[[:xdigit:]]+$ ]]; then
   echo "$0: Invalid Hex number." 1>&2
   exit 1
elif [[ $(( ${#NAMEHEX} % 2 )) -eq 1 ]]; then
   echo "$0: Uneven hex string." 1>&2
   exit 1
fi
NAMEHEX=`echo ${NAMEHEX^^}`

#echo "Namehex: $NAMEHEX"

NAME=""
for (( i=0; i<${#NAMEHEX}; i=i+2 ))
do
   CHARHEX=${NAMEHEX:$i:2}
   NAMECHAR=`grep $CHARHEX "$SCRIPTDIR/charactermap" | awk -F ';' '{print $2}'`
   NAME="$NAME$NAMECHAR"
done
echo "$NAME"

